# Add project specific ProGuard rules here.
# By default, the flags in this file are appended to flags specified
# in /Users/baidu/AndroidDev/adt-bundle-mac-x86_64-20140702/sdk/tools/proguard/proguard-android.txt
# You can edit the include path and order by changing the proguardFiles
# directive in build.gradle.
#
# For more details, see
#   http://developer.android.com/guide/developing/tools/proguard.html

# Add any project specific keep options here:

# If your project uses WebView with JS, uncomment the following
# and specify the fully qualified class name to the JavaScript interface
# class:
#-keepclassmembers class fqcn.of.javascript.interface.for.webview {
#   public *;
#}

# Uncomment this to preserve the line number information for
# debugging stack traces.
#-keepattributes SourceFile,LineNumberTable

# If you keep the line number information, uncomment this to
# hide the original source file name.
#-renamesourcefileattribute SourceFile


#指定代码的压缩级别
-optimizationpasses 5

#包明不混合大小写
-dontusemixedcaseclassnames

#不去忽略非公共的库类
-dontskipnonpubliclibraryclasses

 #优化  不优化输入的类文件
-dontoptimize

 #预校验
-dontpreverify

 #混淆时是否记录日志
-verbose

 # 混淆时所采用的算法
-optimizations !code/simplification/arithmetic,!field/*,!class/merging/*

#保护注解
-keepattributes *Annotation*

# 保持哪些类不被混淆
-keep public class * extends android.app.Fragment
-keep public class * extends android.app.Activity
-keep public class * extends android.app.Application
-keep public class * extends android.app.Service
-keep public class * extends android.content.BroadcastReceiver
-keep public class * extends android.content.ContentProvider
-keep public class * extends android.app.backup.BackupAgentHelper
-keep public class * extends android.preference.Preference
-keep public class com.android.vending.licensing.ILicensingService
#如果有引用v4包可以添加下面这行
-keep public class * extends android.support.v4.app.Fragment




#忽略警告
-ignorewarning

#####################记录生成的日志数据,gradle build时在本项目根目录输出-start################
#apk 包内所有 class 的内部结构
-dump class_files.txt
#未混淆的类和成员
-printseeds seeds.txt
#列出从 apk 中删除的代码
-printusage unused.txt
#混淆前后的映射
-printmapping mapping.txt
#####################记录生成的日志数据，gradle build时 在本项目根目录输出-end################

################<span></span>混淆保护自己项目的部分代码以及引用的第三方jar包library-start############
#以libaray的形式引用了一个图片加载框架,如果不想混淆 keep 掉 示例

#忽略警告
-dontwarn com.veidy.mobile.common.**
#保留一个完整的包
-keep class com.veidy.mobile.common.** {*;}


#-keep class com.ducaller.fsdk.task.JobSchedulerService{*;}
#-keep class com.ducaller.fsdk.main.DuCallerSDKHelper{*;}

#-keep class com.whosthat.phone.widget.FloatPhoneView {*;}
#如果引用了v4或者v7包
-dontwarn android.support.**
-ignorewarnings
-keep class android.support.v4.** { *; }
-keep interface android.support.v4.app.** { *; }
-keep public class * extends android.support.v4.**
-keep public class * extends android.app.Fragment
#-keep public class com.baidu.crabsdk.**
############混淆保护自己项目的部分代码以及引用的第三方jar包library-end##################
#-keepclassmembers public class com.baidu.crabsdk.*{
#*;
#}


-keep public class * extends android.view.View {
    public <init>(android.content.Context);
    public <init>(android.content.Context, android.util.AttributeSet);
    public <init>(android.content.Context, android.util.AttributeSet, int);
    public void set*(...);
}

#保持 native 方法不被混淆
-keepclasseswithmembernames class * {
    native <methods>;
}

#保持自定义控件类不被混淆
-keepclassmembers class * extends android.app.Activity {
   public void *(android.view.View);
}

#保持 Parcelable 不被混淆
-keep class * implements android.os.Parcelable {
  public static final android.os.Parcelable$Creator *;
}

#保持 Serializable 不被混淆
-keepnames class * implements java.io.Serializable

#保持 Serializable 不被混淆并且enum 类也不被混淆
-keepclassmembers class * implements java.io.Serializable {
    static final long serialVersionUID;
    private static final java.io.ObjectStreamField[] serialPersistentFields;
    !static !transient <fields>;
    !private <fields>;
    !private <methods>;
    private void writeObject(java.io.ObjectOutputStream);
    private void readObject(java.io.ObjectInputStream);
    java.lang.Object writeReplace();
    java.lang.Object readResolve();
}

#保持枚举 enum 类不被混淆 如果混淆报错，建议直接使用上面的 -keepclassmembers class * implements java.io.Serializable即可
-keepclassmembers enum * {
  public static **[] values();
  public static ** valueOf(java.lang.String);
}


#不混淆资源类
-keepclassmembers class **.R$* {
    public static <fields>;
}

-keep class com.google.android.gms.common.GooglePlayServicesUtil {
public <methods>;
}
-keep class com.google.android.gms.ads.identifier.AdvertisingIdClient {
public <methods>;
}
-keep class com.google.android.gms.ads.identifier.AdvertisingIdClient$Info {
public <methods>;
}


-dontwarn com.facebook.ads.internal.**
#
#-keep class com.duapps.ad.DuNativeAd {
#        public <methods>;
#}
#-keep class com.duapps.ad.IDuAdController { *; }
#-keep class com.duapps.ad.AdError { *; }
#-keep class com.duapps.ad.PullRequestController {
#        public <methods>;
#}
#-keep class com.duapps.ad.DuAdListener { *; }
#-keep class com.facebook.ads.**{*;}
#
#
#-keep class com.facebook.ads.NativeAd
#-keep class com.duapps.ad.DuAdListener
-keep class com.duapps.ad.**{*;}

#-keep class com.duapps.ad.base.DuAdNetwork {
#    public static void init(android.content.Context,java.lang.String);
#    public static void onPackageAddReceived(android.content.Context,android.content.Intent);
#    public static void onConnectiveReceived(android.content.Context,android.content.Intent);
#}
-keep class com.android.internal.telephony.ITelephony{*;}